import { Notification, Observable } from 'rxjs';
import { ChangeDetectorRef, Type } from '@angular/core';
export declare type coalescingObj = Record<string | number | symbol, unknown> | Type<unknown> | object;
export interface CoalescingOptions {
    scope?: coalescingObj;
}
export declare enum RxNotificationKind {
    suspense = "suspense",
    next = "next",
    error = "error",
    complete = "complete"
}
declare type NotificationValue = 'value' | 'hasValue';
export declare type RxNextNotification<T> = Pick<Notification<T>, NotificationValue> & {
    kind: RxNotificationKind;
} & {
    error: boolean;
} & {
    complete: boolean;
};
export declare type RxSuspenseNotification = Pick<Notification<unknown>, NotificationValue> & {
    kind: RxNotificationKind.suspense;
} & {
    error: false;
} & {
    complete: false;
};
export declare type RxErrorNotification = Pick<Notification<unknown>, NotificationValue> & {
    kind: RxNotificationKind.error;
} & {
    error: any;
} & {
    complete: false;
};
export declare type RxCompleteNotification = Pick<Notification<unknown>, NotificationValue> & {
    kind: RxNotificationKind.complete;
} & {
    complete: boolean;
} & {
    error: false;
};
export declare type RxNotification<T> = RxNextNotification<T> | RxSuspenseNotification | RxErrorNotification | RxCompleteNotification;
export declare type RenderWork = <T = unknown>(cdRef: ChangeDetectorRef, scope?: coalescingObj, notification?: RxNotification<T>) => void;
export declare type RenderBehavior = <T = unknown>(work: any, scope?: coalescingObj) => (o: Observable<T>) => Observable<T>;
export interface StrategyCredentials<S = string> {
    name: S;
    work: RenderWork;
    behavior: RenderBehavior;
}
export declare type CustomStrategyCredentialsMap<T extends string> = Record<T, StrategyCredentials>;
export {};
//# sourceMappingURL=model.d.ts.map