import { ChangeDetectorRef } from '@angular/core';
import { MonoTypeOperatorFunction, Observable } from 'rxjs';
import { CustomStrategyCredentialsMap, StrategyCredentials } from '../model';
import { ScheduleOnStrategyOptions, Strategies, StrategyNames } from './model';
export declare class StrategyProvider<T extends string = string> {
    private _strategies$;
    private _primaryStrategy$;
    get strategies(): Strategies<T>;
    get strategyNames(): string[];
    get primaryStrategy(): StrategyNames<T>;
    set primaryStrategy(strategyName: StrategyNames<T>);
    readonly primaryStrategy$: Observable<StrategyCredentials>;
    readonly strategies$: Observable<Record<StrategyNames<T>, StrategyCredentials<string>>>;
    readonly strategyNames$: Observable<string[]>;
    constructor(defaultStrategy: StrategyNames<T>, customStrategies: CustomStrategyCredentialsMap<T>[]);
    scheduleWith<R>(work: (v?: R) => void, options?: ScheduleOnStrategyOptions): MonoTypeOperatorFunction<R>;
    schedule<R>(work: () => R, options?: ScheduleOnStrategyOptions): Observable<R>;
    scheduleCD(cdRef: ChangeDetectorRef, options?: ScheduleOnStrategyOptions & {
        afterCD?: () => void;
        abortCtrl?: AbortController;
    }): AbortController;
}
//# sourceMappingURL=strategy-provider.service.d.ts.map