import { TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { RenderAware, RxRenderSettings, RxBaseTemplateNames, RxViewContext, TemplateSettings } from './model';
import { RxNotification, RxNotificationKind } from '../model';
export interface RxTemplateManager<T, C extends RxViewContext<T>, N = RxBaseTemplateNames | string> extends RenderAware<T> {
    addTemplateRef: (name: N, templateRef: TemplateRef<C>) => void;
    addTrigger: (trigger$: Observable<RxNotification<T>>) => void;
}
export declare type NotificationTemplateNameMap<T, C, N> = Record<RxNotificationKind, (value?: T, templates?: {
    get: (name: N) => TemplateRef<C>;
}) => N>;
/**
 * @internal
 *
 * A factory function that returns a map of projections to turn a notification of a Observable (next, error, complete)
 *
 * @param customNextContext - projection function to provide custom properties as well as override existing
 */
export declare function notificationKindToViewContext<T>(customNextContext: (value: T) => object): RxViewContextMap<T>;
export declare type RxViewContextMap<T> = Record<RxNotificationKind, (value?: any) => Partial<RxViewContext<T>>>;
export declare function createTemplateManager<T, C extends RxViewContext<T>, N = RxBaseTemplateNames | string>(config: {
    renderSettings: RxRenderSettings<T, C>;
    templateSettings: TemplateSettings<T, C>;
    templateTrigger$?: Observable<RxNotificationKind>;
    notificationToTemplateName: NotificationTemplateNameMap<T, C, N>;
}): RxTemplateManager<T, C, N>;
//# sourceMappingURL=template-manager.d.ts.map