import { StrategyCredentials, CustomStrategyCredentialsMap } from '../model';
import { Observable } from 'rxjs';
/**
 * @internal
 *
 * A factory function returning an object to handle the process of turning strategy names into `StrategyCredentials`
 * You can next a strategy name as Observable or string and get an Observable of `StrategyCredentials`
 *
 * @param defaultStrategyName
 * @param strategies
 */
export declare function strategyHandling(defaultStrategyName: string, strategies: CustomStrategyCredentialsMap<string>): {
    strategy$: Observable<StrategyCredentials>;
    next(name: string | Observable<string>): void;
};
//# sourceMappingURL=strategy-handling.d.ts.map